<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_recurring_settings.php                             ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("sales_orders");
	check_admin_security("payment_systems");

	$payment_id = get_param("payment_id");
	$setting_type = "recurring_" . $payment_id;
	$sql = " SELECT payment_name FROM " . $table_prefix . "payment_systems WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$payment_name = get_translation($db->f("payment_name"), $language_code);
	} else {
		header ("Location: admin_payment_systems.php");
		exit;
	}

	$message_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_recurring_settings.html");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_recurring_settings_href", "admin_recurring_settings.php");
	$t->set_var("admin_order_help_href", "admin_order_help.php");
	$t->set_var("admin_email_help_href", "admin_email_help.php");
	$t->set_var("admin_payment_system_href",  "admin_payment_system.php");
	$t->set_var("admin_payment_systems_href", "admin_payment_systems.php");

	$t->set_var("payment_id",   $payment_id);
	$t->set_var("payment_name", $payment_name);

	$order_statuses = get_db_values("SELECT * FROM " . $table_prefix . "order_statuses", array(array("", "")));

	$r = new VA_Record($table_prefix . "global_settings");
	$r->add_select("new_status_id", TEXT, $order_statuses, "Success Status");
	$r->add_textbox("recurring_attempts", INTEGER);
	$r->add_textbox("recurring_next_attempt", INTEGER);

	// on creation parameters
	$r->add_checkbox("admin_notify_new", INTEGER);
	$r->add_textbox("admin_mail_to_new", TEXT);
	$r->add_textbox("admin_mail_from_new", TEXT);
	$r->add_textbox("admin_mail_cc_new", TEXT);
	$r->add_textbox("admin_mail_bcc_new", TEXT);
	$r->add_textbox("admin_mail_reply_to_new", TEXT);
	$r->add_textbox("admin_mail_return_path_new", TEXT);
	$r->add_textbox("admin_mail_subject_new", TEXT);
	$r->add_radio("admin_mail_type_new", TEXT, $message_types);
	$r->add_textbox("admin_mail_body_new", TEXT);

	$r->add_checkbox("user_notify_new", INTEGER);
	$r->add_textbox("user_mail_from_new", TEXT);
	$r->add_textbox("user_mail_cc_new", TEXT);
	$r->add_textbox("user_mail_bcc_new", TEXT);
	$r->add_textbox("user_mail_reply_to_new", TEXT);
	$r->add_textbox("user_mail_return_path_new", TEXT);
	$r->add_textbox("user_mail_subject_new", TEXT);
	$r->add_radio("user_mail_type_new", TEXT, $message_types);
	$r->add_textbox("user_mail_body_new", TEXT);

	$r->add_checkbox("admin_sms_new", INTEGER);
	$r->add_textbox("admin_sms_recipient_new", TEXT, "Administrator SMS Recipient (On Creation)");
	$r->add_textbox("admin_sms_originator_new", TEXT, "Administator SMS Originator (On Creation)");
	$r->add_textbox("admin_sms_message_new", TEXT, "Administator SMS Message (On Creation)");

	$r->add_checkbox("user_sms_new", INTEGER);
	$r->add_textbox("user_sms_recipient_new", TEXT, "User SMS Recipient (On Creation)");
	$r->add_textbox("user_sms_originator_new", TEXT, "User SMS Originator (On Creation)");
	$r->add_textbox("user_sms_message_new", TEXT, "User SMS Message (On Creation)");

	// on success parameters
	$r->add_checkbox("admin_notify_success", INTEGER);
	$r->add_textbox("admin_mail_to_success", TEXT);
	$r->add_textbox("admin_mail_from_success", TEXT);
	$r->add_textbox("admin_mail_cc_success", TEXT);
	$r->add_textbox("admin_mail_bcc_success", TEXT);
	$r->add_textbox("admin_mail_reply_to_success", TEXT);
	$r->add_textbox("admin_mail_return_path_success", TEXT);
	$r->add_textbox("admin_mail_subject_success", TEXT);
	$r->add_radio("admin_mail_type_success", TEXT, $message_types);
	$r->add_textbox("admin_mail_body_success", TEXT);

	$r->add_checkbox("user_notify_success", INTEGER);
	$r->add_textbox("user_mail_from_success", TEXT);
	$r->add_textbox("user_mail_cc_success", TEXT);
	$r->add_textbox("user_mail_bcc_success", TEXT);
	$r->add_textbox("user_mail_reply_to_success", TEXT);
	$r->add_textbox("user_mail_return_path_success", TEXT);
	$r->add_textbox("user_mail_subject_success", TEXT);
	$r->add_radio("user_mail_type_success", TEXT, $message_types);
	$r->add_textbox("user_mail_body_success", TEXT);

	$r->add_checkbox("admin_sms_success", INTEGER);
	$r->add_textbox("admin_sms_recipient_success", TEXT, "Administrator SMS Recipient (On Success)");
	$r->add_textbox("admin_sms_originator_success", TEXT, "Administator SMS Originator (On Success)");
	$r->add_textbox("admin_sms_message_success", TEXT, "Administator SMS Message (On Success)");

	$r->add_checkbox("user_sms_success", INTEGER);
	$r->add_textbox("user_sms_recipient_success", TEXT, "User SMS Recipient (On Success)");
	$r->add_textbox("user_sms_originator_success", TEXT, "User SMS Originator (On Success)");
	$r->add_textbox("user_sms_message_success", TEXT, "User SMS Message (On Success)");

	// on pending parameters
	$r->add_checkbox("admin_notify_pending", INTEGER);
	$r->add_textbox("admin_mail_to_pending", TEXT);
	$r->add_textbox("admin_mail_from_pending", TEXT);
	$r->add_textbox("admin_mail_cc_pending", TEXT);
	$r->add_textbox("admin_mail_bcc_pending", TEXT);
	$r->add_textbox("admin_mail_reply_to_pending", TEXT);
	$r->add_textbox("admin_mail_return_path_pending", TEXT);
	$r->add_textbox("admin_mail_subject_pending", TEXT);
	$r->add_radio("admin_mail_type_pending", TEXT, $message_types);
	$r->add_textbox("admin_mail_body_pending", TEXT);

	$r->add_checkbox("user_notify_pending", INTEGER);
	$r->add_textbox("user_mail_from_pending", TEXT);
	$r->add_textbox("user_mail_cc_pending", TEXT);
	$r->add_textbox("user_mail_bcc_pending", TEXT);
	$r->add_textbox("user_mail_reply_to_pending", TEXT);
	$r->add_textbox("user_mail_return_path_pending", TEXT);
	$r->add_textbox("user_mail_subject_pending", TEXT);
	$r->add_radio("user_mail_type_pending", TEXT, $message_types);
	$r->add_textbox("user_mail_body_pending", TEXT);

	$r->add_checkbox("admin_sms_pending", INTEGER);
	$r->add_textbox("admin_sms_recipient_pending", TEXT, "Administrator SMS Recipient (On Pending)");
	$r->add_textbox("admin_sms_originator_pending", TEXT, "Administator SMS Originator (On Pending)");
	$r->add_textbox("admin_sms_message_pending", TEXT, "Administator SMS Message (On Pending)");

	$r->add_checkbox("user_sms_pending", INTEGER);
	$r->add_textbox("user_sms_recipient_pending", TEXT, "User SMS Recipient (On Pending)");
	$r->add_textbox("user_sms_originator_pending", TEXT, "User SMS Originator (On Pending)");
	$r->add_textbox("user_sms_message_pending", TEXT, "User SMS Message (On Pending)");

	// on failure parameters
	$r->add_checkbox("admin_notify_failure", INTEGER);
	$r->add_textbox("admin_mail_to_failure", TEXT);
	$r->add_textbox("admin_mail_from_failure", TEXT);
	$r->add_textbox("admin_mail_cc_failure", TEXT);
	$r->add_textbox("admin_mail_bcc_failure", TEXT);
	$r->add_textbox("admin_mail_reply_to_failure", TEXT);
	$r->add_textbox("admin_mail_return_path_failure", TEXT);
	$r->add_textbox("admin_mail_subject_failure", TEXT);
	$r->add_radio("admin_mail_type_failure", TEXT, $message_types);
	$r->add_textbox("admin_mail_body_failure", TEXT);

	$r->add_checkbox("user_notify_failure", INTEGER);
	$r->add_textbox("user_mail_from_failure", TEXT);
	$r->add_textbox("user_mail_cc_failure", TEXT);
	$r->add_textbox("user_mail_bcc_failure", TEXT);
	$r->add_textbox("user_mail_reply_to_failure", TEXT);
	$r->add_textbox("user_mail_return_path_failure", TEXT);
	$r->add_textbox("user_mail_subject_failure", TEXT);
	$r->add_radio("user_mail_type_failure", TEXT, $message_types);
	$r->add_textbox("user_mail_body_failure", TEXT);

	$r->add_checkbox("admin_sms_failure", INTEGER);
	$r->add_textbox("admin_sms_recipient_failure", TEXT, "Administrator SMS Recipient (On Failure)");
	$r->add_textbox("admin_sms_originator_failure", TEXT, "Administator SMS Originator (On Failure)");
	$r->add_textbox("admin_sms_message_failure", TEXT, "Administator SMS Message (On Failure)");

	$r->add_checkbox("user_sms_failure", INTEGER);
	$r->add_textbox("user_sms_recipient_failure", TEXT, "User SMS Recipient (On Failure)");
	$r->add_textbox("user_sms_originator_failure", TEXT, "User SMS Originator (On Failure)");
	$r->add_textbox("user_sms_message_failure", TEXT, "User SMS Message (On Failure)");

	$r->get_form_values();

	$operation = get_param("operation");
	$current_tab = get_param("current_tab");
	if (!$current_tab) { $current_tab = "general"; }
	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin_payment_systems.php";

	if(strlen($operation))
	{
		$current_tab = "general";
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}

		if ($r->get_value("admin_sms_new")) {
			$r->change_property("admin_sms_recipient_new", REQUIRED, true);
			$r->change_property("admin_sms_message_new", REQUIRED, true);
		}
		if ($r->get_value("user_sms_new")) {
			$r->change_property("user_sms_message_new", REQUIRED, true);
		}

		if ($r->get_value("admin_sms_success")) {
			$r->change_property("admin_sms_recipient_success", REQUIRED, true);
			$r->change_property("admin_sms_message_success", REQUIRED, true);
		}
		if ($r->get_value("user_sms_success")) {
			$r->change_property("user_sms_message_success", REQUIRED, true);
		}

		if ($r->get_value("admin_sms_pending")) {
			$r->change_property("admin_sms_recipient_pending", REQUIRED, true);
			$r->change_property("admin_sms_message_pending", REQUIRED, true);
		}
		if ($r->get_value("user_sms_pending")) {
			$r->change_property("user_sms_message_pending", REQUIRED, true);
		}

		if ($r->get_value("admin_sms_failure")) {
			$r->change_property("admin_sms_recipient_failure", REQUIRED, true);
			$r->change_property("admin_sms_message_failure", REQUIRED, true);
		}
		if ($r->get_value("user_sms_failure")) {
			$r->change_property("user_sms_message_failure", REQUIRED, true);
		}
		
		$is_valid = $r->validate();

		if(!strlen($r->errors))
		{
			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
			$db->query($sql);
			foreach($r->parameters as $key => $value)
			{
				$sql  = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES (";
				$sql .= $db->tosql($setting_type, TEXT) . ", '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
	}
	else // get order_info settings
	{
		foreach($r->parameters as $key => $value)
		{
			$sql  = "SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= "WHERE setting_type=" . $db->tosql($setting_type, TEXT) . " AND setting_name='" . $key . "'";
			$r->set_value($key, get_db_value($sql));
		}
	}

	$r->set_parameters();
	$t->set_var("rp", htmlspecialchars($return_page));

	// set styles for tabs
	$tabs = array("general" => "General", "notify_new" => "On Creation", "notify_success" => "On Success", 
		"notify_pending" => "On Pending", "notify_failure" => "On Failure");
	foreach ($tabs as $tab_name => $tab_title) {
		$t->set_var("tab_id", "tab_" . $tab_name);
		$t->set_var("tab_name", $tab_name);
		$t->set_var("tab_title", $tab_title);
		if ($tab_name == $current_tab) {
			$t->set_var("tab_class", "adminTabActive");
			$t->set_var($tab_name . "_style", "display: block;");
		} else {
			$t->set_var("tab_class", "adminTab");
			$t->set_var($tab_name . "_style", "display: none;");
		}
		$t->parse("tabs", $tab_title);
	}
	$t->set_var("current_tab", $current_tab);


	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>