<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  block_login.php                                          ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


function login_form($block_name, $block_prefix = "")
{
	global $t, $db, $table_prefix, $settings;

	if($block_name) {
	  $t->set_file("block_body", "block_login.html");
	}

	$t->set_var("LOGIN_TITLE",    LOGIN_TITLE);
	$t->set_var("CLICK_HERE_MSG", CLICK_HERE_MSG);

  $t->set_var("user_home_href", "user_home.php");
  $t->set_var("forgot_password_href", "forgot_password.php");

	$query_string = transfer_params("", true);

	$login_action = get_param("login_action");
	$login_errors = ""; $user_login = "";
	if(strlen($login_action))
	{
		if($login_action == "logout")
		{
			set_session("session_user_id", "");
			set_session("session_user_type_id", "");
			set_session("session_user_login", "");
			set_session("session_user_name", "");
			set_session("session_user_email", "");
			set_session("session_discount_type", "");
			set_session("session_discount_amount", "");
			set_session("session_price_type", "");
			set_session("session_user_info", "");
			if (get_setting_value($settings, "logout_cart_clear", 0) == 1) {
				set_session("shopping_cart", "");
				set_session("session_coupons", "");
			}

		}
		else
		{

			$user_login = get_param("user_login");
			$user_password = get_param("user_password");
			
			if(!strlen($user_login)) {
				$error_message = str_replace("{field_name}", LOGIN_FIELD, REQUIRED_MESSAGE);
				$login_errors .= $error_message . "<br>";
			}
	  
			if(!strlen($user_password)) {
				$error_message = str_replace("{field_name}", PASSWORD_FIELD, REQUIRED_MESSAGE);
				$login_errors .= $error_message . "<br>";
			}

			if(!$login_errors && check_black_ip()) {
				$login_errors = BLACK_IP_MSG;
			}
			
			if(!strlen($login_errors))
			{
				$password_encrypt = get_setting_value($settings, "password_encrypt", 0);
				if ($password_encrypt == 1) {
					$password_match = md5($user_password);
				} else {
					$password_match = $user_password;
				}

				$sql  = " SELECT u.user_id,u.user_type_id,u.name,u.first_name,u.last_name,u.email,u.is_approved, ";
				$sql .= " u.discount_type AS user_discount_type, u.discount_amount AS user_discount_amount, ";
				$sql .= " ut.discount_type AS group_discount_type, ut.discount_amount AS group_discount_amount, ";
				$sql .= " u.tax_free AS user_tax_free, ut.tax_free AS group_tax_free, ";
				$sql .= " ut.price_type, c.currency_code ";
				$sql .= " FROM ((" . $table_prefix . "users u ";
				$sql .= " LEFT JOIN " . $table_prefix . "user_types ut ON u.user_type_id=ut.type_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "countries c ON u.country_code=c.country_code) ";
				$sql .= " WHERE login=" . $db->tosql($user_login, TEXT);
				$sql .= " AND password=" . $db->tosql($password_match, TEXT);
				$db->query($sql);
				if($db->next_record())
				{
					$is_approved = $db->f("is_approved");
					if ($is_approved) {

						$user_id = $db->f("user_id");
						$user_type_id = $db->f("user_type_id");
						$email = $db->f("email");
						$currency_code = $db->f("currency_code");
						$user_discount_type = $db->f("user_discount_type");
						$user_discount_amount = $db->f("user_discount_amount");
						$group_discount_type = $db->f("group_discount_type");
						$group_discount_amount = $db->f("group_discount_amount");
						$price_type = $db->f("price_type");
						$user_tax_free = $db->f("user_tax_free");
						$group_tax_free = $db->f("group_tax_free");
						$tax_free = ($user_tax_free || $group_tax_free);
				  
						set_session("session_user_id", $user_id);
						set_session("session_user_type_id", $user_type_id);
						set_session("session_user_login", $user_login);
						if(strlen($db->f("name"))) {
							$user_name = $db->f("name");
						} else if (strlen($db->f("first_name")) || strlen($db->f("last_name"))) {
							$user_name = $db->f("first_name") . " " . $db->f("last_name");
						} else {
							$user_name = $user_login;
						}
						set_session("session_user_name", $user_name);
						set_session("session_user_email", $email);
						$discount_type = ""; $discount_amount = "";
						if ($user_discount_type > 0) {
							$discount_type = $user_discount_type;
							$discount_amount = $user_discount_amount;
						} else if ($group_discount_type)  {
							$discount_type = $group_discount_type;
							$discount_amount = $group_discount_amount;
						}
						set_session("session_discount_type", $discount_type);
						set_session("session_discount_amount", $discount_amount);
						set_session("session_price_type", $price_type);
				  
						$user_info = array(
							"user_id" => $user_id, "user_type_id" => $user_type_id, "login" => $user_login, "name" => $user_name,
							"email" => $email, "discount_type" => $discount_type, "discount_amount" => $discount_amount,
							"price_type" => $price_type, "tax_free" => $tax_free
						);
						set_session("session_user_info", $user_info);
				  
						// get currency if available
						if ($currency_code) {
							get_currency($currency_code);
						}
				  
						// update last visit time
						$sql  = " UPDATE " . $table_prefix . "users SET last_visit_date=" . $db->tosql(va_time(), DATETIME);
						$sql .= ", last_visit_ip=" . $db->tosql(get_ip(), TEXT);
						$sql .= " WHERE user_id=" . $db->tosql($user_id, INTEGER);
						$db->query($sql);
				  
						header("Location: user_home.php");
						exit;
					} else {
						$login_errors .= ACCOUNT_APPROVE_ERROR . "<br>";
					}
				}
				else
				{
					$login_errors .= LOGIN_PASSWORD_ERROR . "<br>";
				}
			}
		}
	}

	if(get_session("session_user_id"))	
	{
		$t->set_var("LOGIN_AS_MSG",     LOGIN_AS_MSG);
		$t->set_var("ACCESS_HOME_MSG",  ACCESS_HOME_MSG);
		$t->set_var("LOGOUT_BUTTON",    LOGOUT_BUTTON);

		$t->set_var("user_login", get_session("session_user_login"));
		$t->set_var("user_name", get_session("session_user_name"));
		$t->set_var("login_action", "logout");
		$t->set_var("login_form", "");
		$t->parse($block_prefix . "logout_form", false);
	}
	else
	{
		$t->set_var("LOGIN_FIELD",        LOGIN_FIELD);
		$t->set_var("PASSWORD_FIELD",     PASSWORD_FIELD);
		$t->set_var("GO_BUTTON",          GO_BUTTON);
		$t->set_var("FORGOT_PASSWORD_MSG",FORGOT_PASSWORD_MSG);


		$t->set_var("user_login", htmlspecialchars($user_login));
		$t->set_var("login_action", "login");
		$t->set_var("logout_form", "");
		$t->parse($block_prefix . "login_form", false);
	}

	if(strlen($login_errors))
	{
		$t->set_var("errors_list", $login_errors);
		$t->parse($block_prefix . "login_errors", false);
	}

	if($block_name) {
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}

}

?>