<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  order_items_properties.php                               ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


	function order_items_properties($item_id, $item_type_id, $item_price, $parent_item_id, $parent_property_id, $is_bundle, $discount_applicable = true, $properties_discount = 0)
	{
	 	global $t, $db, $table_prefix;
		global $settings, $currency_left, $currency_right, $currency_rate;
		global $shopping_cart, $cart_id, $is_update; // shopping cart variables
		global $item_name, $manufacturer_code; // add options code to the main product code 
		global $properties_ids; 
		global $user_discount_type, $user_discount_amount; // user discount variables
		global $sc_errors; // errors about required properties
		global $properties_info; // array where all the option data will be saved
		global $properties_values, $properties_values_text, $properties_values_html; // text variables for showing option data
		global $additional_price, $options_buying_price, $additional_weight; // variables for adding to product totals

		$eol = get_eol();

		$sql  = " SELECT * ";
		$sql .= " FROM " . $table_prefix . "items_properties ";
		$sql .= " WHERE (item_id=" . $item_id . " OR item_type_id=" . $db->tosql($item_type_id, INTEGER) . ") ";
		$sql .= " AND property_type_id=1 ";
		$sql .= " ORDER BY use_on_checkout, property_order, property_id ";
		$db->query($sql);
		if ($db->next_record()) {
			$pr_rows = array(); $rn = 0;
			do {
				$pr_rows[$rn]["property_id"] = $db->f("property_id");
				$pr_rows[$rn]["property_type_id"] = $db->f("property_type_id");
				$pr_rows[$rn]["property_name"] = $db->f("property_name");
				$pr_rows[$rn]["property_description"] = $db->f("property_description");
				$pr_rows[$rn]["control_type"] = $db->f("control_type");
				$pr_rows[$rn]["control_style"] = $db->f("control_style");
				$pr_rows[$rn]["required"] = $db->f("required");
				$pr_rows[$rn]["use_on_checkout"] = $db->f("use_on_checkout");
				$pr_rows[$rn]["start_html"] = $db->f("start_html");
				$pr_rows[$rn]["middle_html"] = $db->f("middle_html");
				$pr_rows[$rn]["before_control_html"] = $db->f("before_control_html");
				$pr_rows[$rn]["after_control_html"] = $db->f("after_control_html");
				$pr_rows[$rn]["end_html"] = $db->f("end_html");
				$pr_rows[$rn]["onchange_code"] = $db->f("onchange_code");
				$pr_rows[$rn]["onclick_code"] = $db->f("onclick_code");
				$pr_rows[$rn]["control_code"] = $db->f("control_code");
				$rn++;
			} while ($db->next_record());

			for ($rn = 0; $rn < sizeof($pr_rows); $rn++) {
				$property_id = $pr_rows[$rn]["property_id"];
				$property_type_id = $pr_rows[$rn]["property_type_id"];
				$property_name_initial = $pr_rows[$rn]["property_name"];
				$property_name = get_translation($property_name_initial);
				$property_description = $pr_rows[$rn]["property_description"];
				$control_type = $pr_rows[$rn]["control_type"];
				$control_style = $pr_rows[$rn]["control_style"];
				$property_required = $pr_rows[$rn]["required"];
				$use_on_checkout = $pr_rows[$rn]["use_on_checkout"];
				$start_html = $pr_rows[$rn]["start_html"];
				$middle_html = $pr_rows[$rn]["middle_html"];
				$before_control_html = $pr_rows[$rn]["before_control_html"];
				$after_control_html = $pr_rows[$rn]["after_control_html"];
				$end_html = $pr_rows[$rn]["end_html"];
				$onchange_code = $pr_rows[$rn]["onchange_code"];
				$onclick_code = $pr_rows[$rn]["onclick_code"];
				$control_code = $pr_rows[$rn]["control_code"];

				$properties = "";
				if ($parent_item_id) {
					$cp_id = $cart_id . "_" . $parent_property_id . "_" . $property_id;
					if (isset($shopping_cart[$cart_id]["COMPONENTS_PROPERTIES"][$parent_property_id])) {
						$properties = $shopping_cart[$cart_id]["COMPONENTS_PROPERTIES"][$parent_property_id];
					}
				} else {
					$cp_id = $cart_id . "_" . $property_id;
					$properties = $shopping_cart[$cart_id]["PROPERTIES"];
				}

				$property_value_param = ""; $property_value_params = array();
				$property_value = ""; $pr_add_weight = 0; $pr_add_price = 0; 
				$pr_buy_price = 0; $pr_values = array(); 
				if ($use_on_checkout && !$is_bundle) {
					if ($is_update) {
						if (strtoupper($control_type) == "CHECKBOXLIST") {
							$property_total = get_param("property_total_" . $cp_id);
							for ($i = 1; $i <= $property_total; $i++) {
								$checkbox_value = get_param("property_" . $cp_id . "_" . $i);
								if ($checkbox_value) { $property_value_params[] = $checkbox_value; }
							}

						} else {
							$property_value_param = get_param("property_" . $cp_id);
							$property_value_params = array($property_value_param);
						}
					} else if (is_array($properties) && isset($properties[$property_id])) {
						$property_value_param  = isset($properties[$property_id][0]) ? $properties[$property_id][0] : "";
						$property_value_params = $properties[$property_id];
					}
					if($properties_ids) $properties_ids .= ",";
					$properties_ids .= $cp_id;
					$property_control  = "<input type=\"hidden\" name=\"property_name_" . $cp_id . "\"";
					$property_control .= " value=\"" . htmlspecialchars($property_name) . "\">";
					$property_control .= "<input type=\"hidden\" name=\"property_required_" . $cp_id . "\"";
					$property_control .= " value=\"" . intval($property_required) . "\">";
					$property_control .= "<input type=\"hidden\" name=\"property_control_" . $cp_id . "\"";
					$property_control .= " value=\"" . strtoupper($control_type) . "\">";

					if(strtoupper($control_type) == "LISTBOX") {
						$properties_options = "<option value=\"\">" . SELECT_MSG . " " . $property_name . "</option>" . $eol;
						$sql  = " SELECT * FROM " . $table_prefix . "items_properties_values ";
						$sql .= " WHERE property_id=" . $property_id . " AND hide_value=0 ";
						$sql .= " AND ((hide_out_of_stock=1 AND stock_level > 0) OR hide_out_of_stock=0 OR hide_out_of_stock IS NULL) ";
						$sql .= " ORDER BY item_property_id ";
						$db->query($sql);
						while($db->next_record())
						{
							$item_property_id = $db->f("item_property_id");
							$opt_add_price    = round($db->f("additional_price"), 2);
							$percentage_price = $db->f("percentage_price");
							if ($percentage_price && $item_price) {
								$opt_add_price += round(($item_price * $percentage_price) / 100, 2);
							}

							$opt_buy_price    = round($db->f("buying_price"), 2);
							if ($properties_discount > 0) {
								$opt_add_price -= round(($opt_add_price * $properties_discount) / 100, 2);
							}
							if ($discount_applicable && $user_discount_type == 1) {
								$opt_add_price -= round(($opt_add_price * $user_discount_amount) / 100, 2);
							} else if ($discount_applicable && $user_discount_type == 4) {
								$opt_add_price -= round((($opt_add_price - $opt_buy_price) * $user_discount_amount) / 100, 2);
							}
							$opt_add_weight   = round($db->f("additional_weight"), 4);
							$opt_value        = $db->f("property_value");
							$opt_code         = $db->f("manufacturer_code");
							$option_selected = "";
							if($item_property_id == $property_value_param) {
								$additional_weight += $opt_add_weight;
								$additional_price += $opt_add_price;
								$options_buying_price += $opt_buy_price;
								$pr_add_weight += $opt_add_weight; 
								$pr_add_price += $opt_add_price;
								$manufacturer_code .= trim($opt_code);
								$option_selected = " selected ";
								$property_value = $opt_value;
								$pr_values[] = array($item_property_id, $db->f("use_stock_level"), $db->f("stock_level"), $db->f("download_path"), $db->f("download_period"));
							}
							$properties_options .= "<option " . $option_selected . " value=\"" . htmlspecialchars($item_property_id) . "\">";
							$properties_options .= htmlspecialchars(get_translation($opt_value));
							if ($opt_add_price > 0) {
								$properties_options .= " (+ " . $currency_left . number_format($opt_add_price * $currency_rate, 2) . $currency_right . ")";
							} else if ($additional_price < 0) {
								$properties_options .= " (- " . $currency_left . number_format(abs($opt_add_price * $currency_rate), 2) . $currency_right . ")";
							}
							$properties_options .= "</option>" . $eol;
						}
						$property_control .= $before_control_html;
						$property_control .= "<select name=\"property_" . $cp_id . "\"";
    				if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						if ($control_code) {	$property_control .= " " . $control_code . " "; }
						$property_control .= ">" . $properties_options . "</select>";
						$property_control .= $after_control_html;
					} else if(strtoupper($control_type) == "RADIOBUTTON" || strtoupper($control_type) == "CHECKBOXLIST") {
						$is_radio = (strtoupper($control_type) == "RADIOBUTTON");
						$input_type = $is_radio ? "radio" : "checkbox";
						$property_control .= "<span";
						if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
						$property_control .= ">";
						$value_number = 0;
						$sql  = " SELECT * FROM " . $table_prefix . "items_properties_values ";
						$sql .= " WHERE property_id=" . $property_id . " AND hide_value=0 ";
						$sql .= " AND ((hide_out_of_stock=1 AND stock_level > 0) OR hide_out_of_stock=0 OR hide_out_of_stock IS NULL) ";
						$sql .= " ORDER BY item_property_id ";
						$db->query($sql);
						while($db->next_record())
						{
							$value_number++;
							$item_property_id = $db->f("item_property_id");
							$opt_add_price    = round($db->f("additional_price"), 2);
							$percentage_price = $db->f("percentage_price");
							if ($percentage_price && $item_price) {
								$opt_add_price += round(($item_price * $percentage_price) / 100, 2);
							}
							$opt_buy_price    = round($db->f("buying_price"), 2);
							if ($properties_discount > 0) {
								$opt_add_price -= round(($opt_add_price * $properties_discount) / 100, 2);
							}
							if ($discount_applicable && $user_discount_type == 1) {
								$opt_add_price -= round(($opt_add_price * $user_discount_amount) / 100, 2);
							} else if ($discount_applicable && $user_discount_type == 4) {
								$opt_add_price -= round((($opt_add_price - $opt_buy_price) * $user_discount_amount) / 100, 2);
							}
							$opt_add_weight   = round($db->f("additional_weight"), 4);
							$opt_value        = $db->f("property_value");
							$opt_code         = $db->f("manufacturer_code");
							$option_checked   = "";
							if (in_array($item_property_id, $property_value_params)) {
								$additional_weight += $opt_add_weight;
								$additional_price += $opt_add_price;
								$options_buying_price += $opt_buy_price;
								$pr_add_weight += $opt_add_weight; 
								$pr_add_price += $opt_add_price;
								$manufacturer_code .= trim($opt_code);
								$option_checked = " checked ";
								if ($property_value) { $property_value .= ", "; }
								$property_value .= get_translation($opt_value);
								$pr_values[] = array($item_property_id, $db->f("use_stock_level"), $db->f("stock_level"), $db->f("download_path"), $db->f("download_period"));
							}
							$control_name = ($is_radio) ? ("property_".$cp_id) : ("property_".$cp_id."_".$value_number);
							$property_control .= $before_control_html;
							$property_control .= "<input type=\"". $input_type . "\" name=\"" . $control_name . "\" ". $option_checked;
							if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
							if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
							if ($control_code) {	$property_control .= " " . $control_code . " "; }
							$property_control .= "value=\"" . htmlspecialchars($item_property_id) . "\">";
							$property_control .= get_translation($opt_value);
							if ($opt_add_price > 0) {
								$property_control .= " (+ " . $currency_left . number_format($opt_add_price * $currency_rate, 2) . $currency_right . ")";
							} else if ($opt_add_price < 0) {
								$property_control .= " (- " . $currency_left . number_format(abs($opt_add_price * $currency_rate), 2) . $currency_right . ")";
							}
							$property_control .= $after_control_html;
						}
						$property_control .= "</span>";
						$property_control .= "<input type=\"hidden\" name=\"property_total_".$cp_id."\" value=\"".$value_number."\">";
					} else if (strtoupper($control_type) == "TEXTBOX") {
						$property_value = $property_value_param;
						$property_control .= $before_control_html;
						$property_control .= "<input type=\"text\" name=\"property_" . $cp_id . "\"";
						if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						$property_control .= " value=\"" . htmlspecialchars($property_value) . "\">";
						$property_control .= $after_control_html;
					} else if (strtoupper($control_type) == "TEXTAREA") {
						$property_value = $property_value_param;
						$property_control .= $before_control_html;
						$property_control .= "<textarea name=\"property_" . $cp_id . "\"";
						if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						$property_control .= ">" . htmlspecialchars($property_value) . "</textarea>";
						$property_control .= $after_control_html;
					} else {
						$property_control .= $before_control_html;
						if ($property_required) {
							$property_value = $property_value_param;
							$property_control .= "<input type=\"hidden\" name=\"property_" . $cp_id . "\" value=\"" . htmlspecialchars($property_description) . "\">";
						}
						$property_control .= "<span";
						if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						if ($onclick_code) {	$property_control .= " onClick=\"" . $onclick_code . "\""; }
						if ($onchange_code) {	$property_control .= " onChange=\"" . $onchange_code . "\""; }
						$property_control .= ">" . get_translation($property_description) . "</span>";
						$property_control .= $after_control_html;
					}
					if($is_update) {
						if ($parent_property_id) {
							$shopping_cart[$cart_id]["COMPONENTS_PROPERTIES"][$parent_property_id][$property_id] = $property_value_params;
						} else {
							$shopping_cart[$cart_id]["PROPERTIES"][$property_id] = $property_value_params;
						}
						if ($property_required && !strlen($property_value)) {
							$property_error = str_replace("{property_name}", $property_name, REQUIRED_PROPERTY_MSG);
							$property_error = str_replace("{product_name}", $item_name, $property_error);
							$sc_errors .= $property_error . "<br>";
						}
					}
					$properties_values_html .= "<br>" . $start_html . $property_name . ": " . $middle_html . $property_control . $end_html;
					if ($property_value) {
						if(strlen($properties_values_text)) $properties_values_text .= "; ";
						$properties_values .= "<br>" . $property_name . ": " . get_translation($property_value);
						$properties_values_text .= $property_name . ": " . get_translation($property_value);
						$properties_info[] = array($property_id, $property_name_initial, $property_value, $pr_add_price, $pr_add_weight, $pr_values);
					}

				} else if (is_array($properties) && isset($properties[$property_id])) {
					$property_values = $properties[$property_id];
					$values_list = ""; $values_list_translation = ""; 
					if(strtoupper($control_type) == "LISTBOX" || strtoupper($control_type) == "RADIOBUTTON" 
						|| strtoupper($control_type) == "CHECKBOXLIST") {
						for($pv = 0; $pv < sizeof($property_values); $pv++) {
							$sql  = " SELECT manufacturer_code, property_value, additional_price, percentage_price, buying_price, ";
							$sql .= " additional_weight, use_stock_level, stock_level, download_path, download_period ";
							$sql .= " FROM " . $table_prefix . "items_properties_values ipv ";
							$sql .= " WHERE property_id=" . $db->tosql($property_id, INTEGER);
							$sql .= " AND item_property_id=" . $db->tosql($property_values[$pv], INTEGER);
							$db->query($sql);
							if($db->next_record()) {
								$pr_code = $db->f("manufacturer_code");
								$opt_add_price = $db->f("additional_price");
								$percentage_price = $db->f("percentage_price");
								if ($percentage_price && $item_price) {
									$opt_add_price += round(($item_price * $percentage_price) / 100, 2);
								}
								$opt_buy_price = $db->f("buying_price");
								if ($properties_discount > 0) {
									$opt_add_price -= round(($opt_add_price * $properties_discount) / 100, 2);
								}
								if ($discount_applicable && $user_discount_type == 1) {
									$opt_add_price -= round(($opt_add_price * $user_discount_amount) / 100, 2);
								} else if ($discount_applicable && $user_discount_type == 4) {
									$opt_add_price -= round((($opt_add_price - $opt_buy_price) * $user_discount_amount) / 100, 2);
								}
								$pr_add_price += $opt_add_price;
								$pr_buy_price += $opt_buy_price;
								$pr_add_weight += $db->f("additional_weight");
								if ($values_list) { $values_list .= ", "; $values_list_translation .= ", "; }
								$values_list .= $db->f("property_value");
								$values_list_translation .= get_translation($db->f("property_value"));
								$manufacturer_code .= $pr_code;
								$pr_values[] = array($property_values[$pv], $db->f("use_stock_level"), $db->f("stock_level"), $db->f("download_path"), $db->f("download_period"));
							} else {
								$shopping_cart[$cart_id]["PROPERTIES"][$property_id] = "";
								unset($shopping_cart[$cart_id]["PROPERTIES"][$property_id]);
							}
						}
						$additional_price += $pr_add_price;
						$options_buying_price += $pr_buy_price;
						$additional_weight += $pr_add_weight;
						if ($pr_add_price > 0) {
							$values_list_translation .= " (+ " . $currency_left . number_format($pr_add_price * $currency_rate, 2) . $currency_right . ")";
						} else if ($pr_add_price < 0) {
							$values_list_translation .= " (- " . $currency_left . number_format(abs($pr_add_price * $currency_rate), 2) . $currency_right . ")";
						}
					} else {
						$values_list = $property_values[0];
						$values_list_translation = get_translation($property_values[0]);
					}

					if(strlen($properties_values_text)) $properties_values_text .= "; ";
					$properties_values .= "<br>" . $property_name . ": " . $values_list_translation;
					if ($control_type == "IMAGEUPLOAD" && preg_match("/^http\:\/\//", $values_list_translation)) { 
						$values_list_translation = "<a href=\"".$values_list_translation."\" target=\"_blank\">" . basename($values_list_translation) . "</a>";
					}
					$properties_values_html .= "<br>" . $property_name . ": " . $values_list_translation;
					$properties_values_text .= $property_name . ": " . $values_list_translation;
					$properties_info[] = array($property_id, $property_name_initial, $values_list, $pr_add_price, $pr_add_weight, $pr_values);
				}
			}
		}

	}

?>