// shopping javacript
function checkOrder(orderForm)
{
	var prMessage = "{REQUIRED_PROPERTY_MSG}";
	var prIDs = orderForm.properties.value;
	if (prIDs != "") {
		var properties = prIDs.split(",");
		for ( var i = 0; i < properties.length; i++) {
			var prID = properties[i];
			var cp = prID.split("_");
			var cartID = "";
			if (cp.length == 4) {
				cartID = cp[0] + "_" + cp[1] + "_" + cp[2];
			} else {
				cartID = cp[0];
			}
			var productName = orderForm.elements["item_name_" + cartID].value;
			var prRequired = orderForm.elements["property_required_" + prID].value;
			if(prRequired == 1) {
				var prValue = "";
				var prControl = orderForm.elements["property_control_" + prID].value;
				if (prControl == "LISTBOX") {
					prValue = orderForm.elements["property_" + prID].options[orderForm.elements["property_" + prID].selectedIndex].value;
				} else if (prControl == "RADIOBUTTON") {
					var radioControl = orderForm.elements["property_" + prID];
					if (radioControl.length) {
						for ( var ri = 0; ri < radioControl.length; ri++) {
							if (radioControl[ri].checked) {
								prValue = radioControl[ri].value;
								break;
							}
						}
					} else {
						if (radioControl.checked) {
							prValue = radioControl.value;
						}
					}
				} else if (prControl == "CHECKBOXLIST") {
					if (orderForm.elements["property_total_" + prID]) {
						var totalOptions = parseInt(orderForm.elements["property_total_" + prID].value);
						for ( var ci = 1; ci <= totalOptions; ci++) {
							if (orderForm.elements["property_" + prID + "_" + ci].checked) {
								prValue = 1;
								break;
							}
						}
					} 
				} else {
					prValue = orderForm.elements["property_" + prID].value;
				}
				if(prValue == "") {
					var propertyName = orderForm.elements["property_name_" + prID].value;
					prMessage = prMessage.replace("\{property_name\}", propertyName);
					prMessage = prMessage.replace("\{product_name\}", productName);
					alert(prMessage);	
					if (prControl != "RADIOBUTTON" && prControl != "CHECKBOXLIST") {
						orderForm.elements["property_" + prID].focus();
					}
					return false;
				}
			}
		}
	}

	if(orderForm.shipping_type_id 
		&& orderForm.shipping_type_id.length 
		&& orderForm.shipping_type_id.length > 1) {
		var shippingError = "{REQUIRED_DELIVERY_MSG}";
		var shippingChecked = false;
		for(var i = 0; i < orderForm.shipping_type_id.length; i++) {
			shippingChecked = (shippingChecked || orderForm.shipping_type_id[i].checked);
		}
		if(!shippingChecked)
		{
			alert(shippingError);
			orderForm.shipping_type_id[0].focus();
			return false;
		}
	} 

	orderForm.operation.value = 'save';
	return true;
}


function changeProperty(orderForm)
{
	var orderProperties = "";
	var currencyLeft = orderForm.currency_left.value;
	var currencyRight = orderForm.currency_right.value;
	var currencyRate = orderForm.currency_rate.value;
	if(orderForm.order_properties) { orderProperties = orderForm.order_properties.value; }
	if(orderProperties != "") {

		var totalPropertiesPrice = 0;
		var propertiesTaxable = 0;
		var properties = orderProperties.split(",");
		for ( var i = 0; i < properties.length; i++) {
			var prID = properties[i];
			var prValue = "";
			var propertyPrice = 0;
			var prControl = orderForm.elements["op_control_" + prID].value;
			var taxFree = parseInt(orderForm.elements["op_tax_free_" + prID].value);
			if (prControl == "LISTBOX") {
				prValue = orderForm.elements["op_" + prID].options[orderForm.elements["op_" + prID].selectedIndex].value;
			} else if (prControl == "RADIOBUTTON") {
				var radioControl = orderForm.elements["op_" + prID];
				if (radioControl.length) {
					for ( var ri = 0; ri < radioControl.length; ri++) {
						if (radioControl[ri].checked) {
							prValue = radioControl[ri].value;
							break;
						}
					}
				} else {
					if (radioControl.checked) {
						prValue = radioControl.value;
					}
				}
			} else if (prControl == "CHECKBOXLIST") {
				if (orderForm.elements["op_total_" + prID]) {
					var totalOptions = parseInt(orderForm.elements["op_total_" + prID].value);
					for ( var ci = 1; ci <= totalOptions; ci++) {
						if (orderForm.elements["op_" + prID + "_" + ci].checked) {
							var checkedValue = orderForm.elements["op_" + prID + "_" + ci].value;
							if (orderForm.elements["op_option_price_" + checkedValue]) {
								var checkedPrice = parseFloat(orderForm.elements["op_option_price_" + checkedValue].value);
								if(!isNaN(checkedPrice) && checkedPrice!= 0) {
									propertyPrice += parseFloat(checkedPrice);
								}
							} 
						}
					}
				} 
			}
			if (prValue != "") {
				if(orderForm.elements["op_option_price_" + prValue]) {
					var optionPrice = orderForm.elements["op_option_price_" + prValue].value;
					if(optionPrice != "") {
						propertyPrice = parseFloat(optionPrice);
					}
				}
			} 

			if(!isNaN(propertyPrice) && propertyPrice != 0) {
				totalPropertiesPrice += propertyPrice;
				if (taxFree != 1) {
					propertiesTaxable += propertyPrice;
				}
			}
			if (orderForm.elements["op_price_" + prID]) {
				if (propertyPrice == 0) {
					orderForm.elements["op_price_" + prID].value = "";
				} else {
					orderForm.elements["op_price_" + prID].value = currencyLeft + formatNumber(propertyPrice * currencyRate) + currencyRight;
				}
			}
		}

		document.order_info.properties_total.value = totalPropertiesPrice;
		document.order_info.properties_taxable.value = propertiesTaxable;
		calculateOrder();
	}
}


function changeShipping(orderForm)
{
	var currencyLeft = orderForm.currency_left.value;
	var currencyRight = orderForm.currency_right.value;
	var currencyRate = orderForm.currency_rate.value;
	var shippingValue = 0; 
	var shippingTaxable = 1; 
	orderForm.shipping_selected_cost.value = 0;
	orderForm.shipping_taxable_value.value = 0;
	if(orderForm.shipping_type_id) {
		for(var i = 0; i < orderForm.shipping_type_id.length; i++)
		{
			if(orderForm.shipping_type_id[i].checked) {
				shippingTaxable = parseInt(orderForm.shipping_taxable[i].value);
				shippingValue = parseFloat(orderForm.shipping_value[i].value);
				orderForm.shipping_cost_selected[i].value = currencyLeft + formatNumber(shippingValue * currencyRate) + currencyRight;
				orderForm.shipping_selected_cost.value = shippingValue;
				if (shippingTaxable == 1) {
					orderForm.shipping_taxable_value.value = shippingValue;
				}
			} else {
				orderForm.shipping_cost_selected[i].value = "";
			}
		}
	}
	calculateOrder();
}

function calculateOrder()
{
	var orderForm = document.order_info;
	var currencyLeft = orderForm.currency_left.value;
	var currencyRight = orderForm.currency_right.value;
	var currencyRate = orderForm.currency_rate.value;
	var goodsTotal = parseFloat(orderForm.goods_value.value);
	var goodsTaxable = parseFloat(orderForm.taxable_value.value);
	var propertiesTotal = parseFloat(orderForm.properties_total.value);
	var propertiesTaxable = parseFloat(orderForm.properties_taxable.value);
	var shippingCost = parseFloat(orderForm.shipping_selected_cost.value);
	var shippingTaxable = parseFloat(orderForm.shipping_taxable_value.value);
	var taxPercent = parseFloat(orderForm.tax_percent.value);
	if(isNaN(taxPercent)) { taxPercent = 0; }

	var goodsTaxValue = 0;
	if (orderForm.goods_tax_value) {
		goodsTaxValue = parseFloat(orderForm.goods_tax_value.value);
	} else {
		goodsTaxValue = Math.round(goodsTaxable * taxPercent) / 100;
	}

	var taxCost = 0;
	if(taxPercent > 0) {
		var taxableAmount = (propertiesTaxable + shippingTaxable);
		var taxCost = goodsTaxValue + Math.round(taxableAmount * taxPercent) / 100;
		orderForm.tax_cost.value = currencyLeft + formatNumber(taxCost * currencyRate) + currencyRight;
	}
	var orderTotal = goodsTotal + propertiesTotal + shippingCost + taxCost;
	// calculate processing fee
	var processingFees = ""; var processingFee = 0;
	if (orderForm.processing_fees && orderForm.processing_fee) {
		processingFees = orderForm.processing_fees.value;
		var feeType = 0;
		var feeValue = 0;
		if (processingFees != "") {
			var feesValues = processingFees.split(",");
			if (feesValues.length == 3) {
				feeType = parseInt(feesValues[1]);
				feeValue = parseFloat(feesValues[2]);
			} else if (feesValues.length > 3) {
				var paymentId = "";
				if (orderForm.payment_id)	{
					paymentId = orderForm.payment_id.options[orderForm.payment_id.selectedIndex].value;
				}		
				for (var f = 0; f < feesValues.length; f = f + 3) {
					feePayment = feesValues[f];
					if (paymentId == feePayment) {
						feeType = parseInt(feesValues[f + 1]);
						feeValue = parseFloat(feesValues[f + 2]);
						break;
					}		
				}
			}
		}
		
		if (feeType == 1) {
			processingFee = Math.round(orderTotal * feeValue) / 100;
		} else {
			processingFee = feeValue;
		}
		orderForm.processing_fee.value = currencyLeft + formatNumber(processingFee * currencyRate) + currencyRight;
	}
	orderTotal += processingFee;

	orderForm.order_total_desc.value = currencyLeft + formatNumber(orderTotal * currencyRate) + currencyRight;
}

function formatNumber(numberValue)
{
	numberValue = Math.round(numberValue * 100) / 100;
	var numberText = new String(numberValue);
	if(numberText.indexOf(".") == -1) {
		numberText += ".00";
	} else if (numberText.indexOf(".") == (numberText.length - 2)) {
		numberText += "0";
	} else {
		var numberParts = numberText.split(".");
		if(numberParts[1].length > 2) {
			numberText = numberParts[0] + "." + numberParts[1].substring(0, 2);
		}
	}
	return numberText;
}

function changeCountry(orderForm, controlType)
{
	var refreshPage = true;
	if(controlType == 'personal') {
		if(orderForm.delivery_country_code) { refreshPage = false; }
	}
	if (refreshPage) {
		orderForm.operation.value = "refresh";
		orderForm.submit();
	}
}

function changeState(orderForm, controlType)
{
	var refreshPage = true;
	if (controlType == 'personal') {
		if (orderForm.delivery_state_code || orderForm.delivery_country_code) { 
			refreshPage = false; 
		} else if (orderForm.country_code) {
			if ( orderForm.country_code.options[orderForm.country_code.selectedIndex].value == "") { refreshPage = false; } 
		}
	} else if (orderForm.delivery_country_code) {
		if ( orderForm.delivery_country_code.options[orderForm.delivery_country_code.selectedIndex].value == "") { refreshPage = false; } 
	}
	if (refreshPage) {
		orderForm.operation.value = "refresh";
		orderForm.submit();
	}
}

function changeZip(orderForm, controlType)
{
	var refreshPage = true;
	if (controlType == 'personal') {
		if (orderForm.delivery_zip || orderForm.delivery_country_code) { 
			refreshPage = false; 
		} else if (orderForm.country_code) {
			if ( orderForm.country_code.options[orderForm.country_code.selectedIndex].value == "") { refreshPage = false; } 
		}
	} else if (orderForm.delivery_country_code) {
		if ( orderForm.delivery_country_code.options[orderForm.delivery_country_code.selectedIndex].value == "") { refreshPage = false; } 
	}
	if (refreshPage) {
		orderForm.operation.value = "refresh";
		orderForm.submit();
	}
}

function checkSame()
{
	var sameChecked = document.order_info.same_as_personal.checked;
	if(sameChecked) {
		var fieldName = "";
		var fields = new Array("name", "first_name", "last_name", "company_id", "company_name", "email", 
			"address1", "address2", "city", "province", "address1", "state_code", "zip", 
			"phone", "daytime_phone", "evening_phone", "cell_phone", "fax");
		var orderForm = document.order_info;
		for (var i = 0; i < fields.length; i++) {
			fieldName = fields[i];
			if (orderForm.elements[fieldName] && orderForm.elements["delivery_" + fieldName]) {
				orderForm.elements["delivery_" + fieldName].value = orderForm.elements[fieldName].value;
			}
		}
		if (orderForm.country_code && orderForm.delivery_country_code) {
			if(orderForm.country_code.selectedIndex != orderForm.delivery_country_code.selectedIndex) {
				orderForm.delivery_country_code.selectedIndex = orderForm.country_code.selectedIndex;
				orderForm.operation.value = "refresh";
				orderForm.submit();
			}
		}
	}
}

function uncheckSame()
{
	if (document.order_info.same_as_personal) {
		document.order_info.same_as_personal.checked = false;
	}
}
