<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  akbank.php                                               ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


/*
 * Akbank (www.est.com.tr) transaction handler by www..com
 */

 	$error_message = "";
	$pass_data = array();
	foreach ($payment_parameters as $parameter_name => $parameter_value) {
		if(isset($pass_parameters[$parameter_name]) && $pass_parameters[$parameter_name] == 1) {
			$pass_data[$parameter_name] = $parameter_value;
		}
	}
	$xml = buildXML($pass_data);
	$xml = "DATA=" . $xml;

	$ch = curl_init ();
	if ($ch) {
		curl_setopt ($ch, CURLOPT_URL, $advanced_url);
		curl_setopt ($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt ($ch, CURLOPT_POST, 1);
		curl_setopt ($ch, CURLOPT_POSTFIELDS, $xml); // the string we built above
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);

		// send the string to Garanti
		$payment_response = curl_exec ($ch);
		curl_close($ch);
		$payment_response = trim($payment_response);
		$t->set_var("payment_response", $payment_response);
		if ($payment_response) {
			//echo nl2br(htmlspecialchars($payment_response)) . "<hr>";
			$response_parameters = array();
			if (preg_match("/<CC5Response>(.*)<\/CC5Response>/sm", $payment_response, $matches)) {
				$payment_response = $matches[1];
				// convert xml into array
				preg_match_all ("/<([^>]*?)>([^<]*?)\<\/[^>]*>/", $payment_response, $matches, PREG_SET_ORDER);
				for($i = 0; $i < sizeof($matches); $i++) {
					$response_parameters[$matches[$i][1]] = ($matches[$i][2]);
				}

				foreach ($response_parameters as $parameter_name => $parameter_value) {
					$t->set_var($parameter_name, $parameter_value);
				}

				// check if transaction approved by payment system
				if (!isset($response_parameters["ProcReturnCode"])) {
					$error_message = "Can't obtain return code.";
				} else if ($response_parameters["ProcReturnCode"] != "0") {
					switch ($response_parameters["ProcReturnCode"]) {
						case "12": $error_message = "Invalid transaction."; break;
						case "51": $error_message = "Not sufficient funds."; break;
						case "54": $error_message = "Expired Card."; break;
						case "82": $error_message = "Incorrect CVV."; break;
						case "93": $error_message = "Transaction cannot be completed (violation of law)."; break;
						case "99":
							$error_message = "Transaction declined. Possible reasons: The card failed compliancy checks, The card has expired, Insufficient permissions to perform requested operation, Value for element 'Total' is not valid.";
							break;
						default: $error_message = "Your transaction has been declined.";
					}
					if (isset($response_parameters["ErrMsg"]) && strlen($response_parameters["ErrMsg"])) {
						$error_message .= " " . $response_parameters["ErrMsg"];
					}
				} else {
					$transaction_id = isset($response_parameters["TransId"]) ? $response_parameters["TransId"] : "0";
				}
			} else {
				$error_message = "Unexpected response format from gateway.";
			}
		} else {
			$error_message = "Empty response from gateway. Please check your settings.";
		}
	} else {
		$error_message = "Can't initialize cURL.";
	}

	//echo htmlspecialchars($payment_response);

	function buildXML($pdata)
	{
		$xml = "<?xml version=\"1.0\" encoding=\"ISO-8859-9\"?>"; //<?
		$xml .= "<CC5Request>";

		// Common fields
		if (isset($pdata["name"]))
			$xml .= "<Name>" . $pdata["name"] . "</Name>";
		if (isset($pdata["password"]))
			$xml .= "<Password>" . $pdata["password"] . "</Password>";
		if (isset($pdata["clientid"]))
			$xml .= "<ClientId>" . $pdata["clientid"] . "</ClientId>";
		$remote_address = get_ip();
		if (strlen($remote_address))
			$xml .= "<IPAddress>" . $remote_address . "</IPAddress>";
		if (isset($pdata["email"]))
			$xml .= "<Email>" . $pdata["email"] . "</Email>";
		if (isset($pdata["mode"]))
			$xml .= "<Mode>" . $pdata["mode"] . "</Mode>";
		if (isset($pdata["orderid"]))
			$xml .= "<OrderId>" . $pdata["orderid"] . "</OrderId>";
		if (isset($pdata["groupid"]))
			$xml .= "<GroupId>" . $pdata["groupid"] . "</GroupId>";
		if (isset($pdata["userid"]))
			$xml .= "<UserId>" . $pdata["userid"] . "</UserId>";
		if (isset($pdata["type"]))
			$xml .= "<Type>" . $pdata["type"] . "</Type>";
		if (isset($pdata["number"]))
			$xml .= "<Number>" . $pdata["number"] . "</Number>";
		if (isset($pdata["expires"]))
			$xml .= "<Expires>" . str_replace(" ", "", $pdata["expires"]) . "</Expires>";
		if (isset($pdata["cvv2val"]))
			$xml .= "<Cvv2Val>" . $pdata["cvv2val"] . "</Cvv2Val>";
		if (isset($pdata["total"]))
			$xml .= "<Total>" . $pdata["total"] . "</Total>";
		if (isset($pdata["currency"]))
			$xml .= "<Currency>" . $pdata["currency"] . "</Currency>";
		if (isset($pdata["taksit"]))
			$xml .= "<Taksit>" . $pdata["taksit"] . "</Taksit>";

		// BillTo node
		$xml .= "<BillTo>";
		if (isset($pdata["billtoname"]))
			$xml .= "<Name>" . $pdata["billtoname"] . "</Name>";
		if (isset($pdata["billtostreet1"]))
			$xml .= "<Street1>" . $pdata["billtostreet1"] . "</Street1>";
		if (isset($pdata["billtostreet2"]))
			$xml .= "<Street2>" . $pdata["billtostreet2"] . "</Street2>";
		if (isset($pdata["billtostreet3"]))
			$xml .= "<Street3>" . $pdata["billtostreet3"] . "</Street3>";
		if (isset($pdata["billtocity"]))
			$xml .= "<City>" . $pdata["billtocity"] . "</City>";
		if (isset($pdata["billtostateprov"]))
			$xml .= "<StateProv>" . $pdata["billtostateprov"] . "</StateProv>";
		if (isset($pdata["billtopostalcode"]))
			$xml .= "<PostalCode>" . $pdata["billtopostalcode"] . "</PostalCode>";
		if (isset($pdata["billtocountry"]))
			$xml .= "<Country>" . $pdata["billtocountry"] . "</Country>";
		if (isset($pdata["billtocompany"]))
			$xml .= "<Company>" . $pdata["billtocompany"] . "</Company>";
		if (isset($pdata["billtotelvoice"]))
			$xml .= "<TelVoice>" . $pdata["billtotelvoice"] . "</TelVoice>";
		$xml .= "</BillTo>";

		// ShipTo node
		$xml .= "<ShipTo>";
		if (isset($pdata["shiptoname"]))
			$xml .= "<Name>" . $pdata["shiptoname"] . "</Name>";
		if (isset($pdata["shiptostreet1"]))
			$xml .= "<Street1>" . $pdata["shiptostreet1"] . "</Street1>";
		if (isset($pdata["shiptostreet2"]))
			$xml .= "<Street2>" . $pdata["shiptostreet2"] . "</Street2>";
		if (isset($pdata["shiptostreet3"]))
			$xml .= "<Street3>" . $pdata["shiptostreet3"] . "</Street3>";
		if (isset($pdata["shiptocity"]))
			$xml .= "<City>" . $pdata["shiptocity"] . "</City>";
		if (isset($pdata["shiptostateprov"]))
			$xml .= "<StateProv>" . $pdata["shiptostateprov"] . "</StateProv>";
		if (isset($pdata["shiptopostalcode"]))
			$xml .= "<PostalCode>" . $pdata["shiptopostalcode"] . "</PostalCode>";
		if (isset($pdata["shiptocountry"]))
			$xml .= "<Country>" . $pdata["shiptocountry"] . "</Country>";
		$xml .= "</ShipTo>";

		// Extra info
		$xml .= "<Extra></Extra>";
		$xml .= "</CC5Request>";

		return $xml;
	}

?>
